searchNodes=[{"type":"module","title":"SnapFramework.Engine.Builder.Component","doc":"","ref":"SnapFramework.Engine.Builder.Component.html"},{"type":"function","title":"SnapFramework.Engine.Builder.Component.build/2","doc":"","ref":"SnapFramework.Engine.Builder.Component.html#build/2"},{"type":"module","title":"SnapFramework.Engine.Builder.Graph","doc":"","ref":"SnapFramework.Engine.Builder.Graph.html"},{"type":"function","title":"SnapFramework.Engine.Builder.Graph.build/2","doc":"","ref":"SnapFramework.Engine.Builder.Graph.html#build/2"},{"type":"module","title":"SnapFramework.Engine.Builder.Grid","doc":"","ref":"SnapFramework.Engine.Builder.Grid.html"},{"type":"function","title":"SnapFramework.Engine.Builder.Grid.build/2","doc":"","ref":"SnapFramework.Engine.Builder.Grid.html#build/2"},{"type":"module","title":"SnapFramework.Engine.Builder.Layout","doc":"Overview This module is responsible for taking the parsed EEx layout and builds the graph.","ref":"SnapFramework.Engine.Builder.Layout.html"},{"type":"function","title":"SnapFramework.Engine.Builder.Layout.build/2","doc":"","ref":"SnapFramework.Engine.Builder.Layout.html#build/2"},{"type":"module","title":"SnapFramework.Engine.Builder.Primitive","doc":"","ref":"SnapFramework.Engine.Builder.Primitive.html"},{"type":"function","title":"SnapFramework.Engine.Builder.Primitive.build/2","doc":"","ref":"SnapFramework.Engine.Builder.Primitive.html#build/2"},{"type":"module","title":"SnapFramework.Engine.Compiler","doc":"","ref":"SnapFramework.Engine.Compiler.html"},{"type":"function","title":"SnapFramework.Engine.Compiler.compile_file/4","doc":"","ref":"SnapFramework.Engine.Compiler.html#compile_file/4"},{"type":"function","title":"SnapFramework.Engine.Compiler.compile_graph/1","doc":"","ref":"SnapFramework.Engine.Compiler.html#compile_graph/1"},{"type":"function","title":"SnapFramework.Engine.Compiler.compile_string/2","doc":"","ref":"SnapFramework.Engine.Compiler.html#compile_string/2"},{"type":"module","title":"SnapFramework.Engine.Compiler.Scrubber","doc":"","ref":"SnapFramework.Engine.Compiler.Scrubber.html"},{"type":"function","title":"SnapFramework.Engine.Compiler.Scrubber.scrub/1","doc":"","ref":"SnapFramework.Engine.Compiler.Scrubber.html#scrub/1"},{"type":"module","title":"SnapFramework.Engine.Parser.Grid","doc":"","ref":"SnapFramework.Engine.Parser.Grid.html"},{"type":"function","title":"SnapFramework.Engine.Parser.Grid.run/1","doc":"","ref":"SnapFramework.Engine.Parser.Grid.html#run/1"},{"type":"module","title":"SnapFramework.Engine.Parser.Layout","doc":"","ref":"SnapFramework.Engine.Parser.Layout.html"},{"type":"function","title":"SnapFramework.Engine.Parser.Layout.run/1","doc":"","ref":"SnapFramework.Engine.Parser.Layout.html#run/1"},{"type":"module","title":"SnapFramework.Scene.Helpers","doc":"","ref":"SnapFramework.Scene.Helpers.html"},{"type":"macro","title":"SnapFramework.Scene.Helpers.sigil_G/2","doc":"","ref":"SnapFramework.Scene.Helpers.html#sigil_G/2"},{"type":"module","title":"SnapFramework.Component","doc":"Overview SnapFramework.Component is nearly identical to a Scene. The main difference is it automatically generates some helper functions and validation functions based on the options you add when use is called. defmodule Example.Component.MyComponent do use SnapFramework.Component , name : :my_component , type : :tuple end The above example defines a component that takes in a tuple for data and builds your helper function defined as my_component/3 Component templates also have an additional feature that primitives or scene templates do not have. You can inject children into them. Lets write a basic icon button component that takes an icon child. defmodule Example.Component.IconButton do use SnapFramework.Component , name : :icon_button def render ( assigns ) do ~G&quot;&quot;&quot; &lt;%= graph font_size: 20 %&gt; &lt;%= primitive Scenic.Primitive.Circle, 15, id: :bg, translate: {23, 23} %&gt; @children &quot;&quot;&quot; end end Now lets see how to use this component with children in a scene. This assumes we've already made an icon component. As you can see we are nesting a component within another component. The compiler will pass any nested components onto the scene of the parent component as children. &lt; % = graph font_size : 20 % &gt; &lt; % = component Example.Component.IconButton , nil , id : :icon_button do % &gt; &lt; % = component Example.Component.Icon , @icon , id : :icon % &gt; &lt; % end % &gt; Additionally because children are assigns in the engine whenever you change them at the top level, the graphs all the way down your component tree will be update. That's all there is to putting children in components!","ref":"SnapFramework.Component.html"},{"type":"behaviour","title":"SnapFramework.Scene","doc":"Overview SnapFramework.Scene aims to make creating Scenic scenes and components easier as well as add more power overall to graph updates and nesting components, and comes with a lot of convenient features. See Scenic.Scene docs for more on scenes. Creating a scene is pretty straight forward. defmodule Example.Scene.MyScene do use SnapFramework.Scene def setup ( scene ) do assign ( scene , dropdown_opts : [ { &quot;Option 1&quot; , &quot;Option 1&quot; } , { &quot;Option 2&quot; , &quot;Option 2&quot; } , { &quot;Option 3&quot; , &quot;Option 3&quot; } ] , dropdown_value : &quot;Option 1&quot; ) end def render ( assigns ) do ~G&quot;&quot;&quot; &lt;%= graph font_size: 20 %&gt; &lt;%= primitive Scenic.Primitive.Text, &quot;selected value \#{@dropdown_value}&quot;, id: :dropdown_value_text, translate: {20, 80} %&gt; &lt;%= component Scenic.Component.Dropdown, { @dropdown_opts, @dropdown_value }, id: :dropdown, translate: {20, 20} %&gt; &quot;&quot;&quot; end def process_event ( { :value_changed , :dropdown , value } , _ , scene ) do { :noreply , assign ( scene , dropdown_value : value ) } end end Having just the above should be enough to get the scene rendering. Whenever you change one of the variables used in the template SnapFramework will automatically rebuild the graph and push it. Setup and Mount Callbacks If you need to do some special setup, like request input, subscribe to a PubSub service, or add some runtime assigns. You can do that in the setup callback. It gives you the scene struct and should return a scene struct. These callbacks do not trigger redraws. The setup callback runs before the graph is initialized. So any added or modified assigns will be included in the template. The graph however is not included on the scene yet. defmodule Example.Scene.MyScene do use SnapFramework.Scene def setup ( scene ) do assign ( scene , dropdown_opts : [ { &quot;Option 1&quot; , &quot;Option 1&quot; } , { &quot;Option 2&quot; , &quot;Option 2&quot; } , { &quot;Option 3&quot; , &quot;Option 3&quot; } ] , dropdown_value : &quot;Option 1&quot; ) end def render ( assigns ) do ~G&quot;&quot;&quot; &lt;%= graph font_size: 20 %&gt; &lt;%= primitive Scenic.Primitive.Text, &quot;selected value \#{@dropdown_value}&quot;, id: :dropdown_value_text, translate: {20, 80} %&gt; &lt;%= component Scenic.Component.Input.Dropdown, { @dropdown_opts, @dropdown_value }, id: :dropdown, translate: {20, 20} %&gt; &quot;&quot;&quot; end def process_event ( { :value_changed , :dropdown , value } , _ , scene ) do { :noreply , assign ( scene , dropdown_value : value ) } end end If you need to do something after the graph is initialized, you can use the mounted callback. Like the setup callback it gives you the scene, and should return a scene. Usually this is for sending events to child components. defmodule Example.Scene.MyScene do use SnapFramework.Scene def setup ( scene ) do assign ( scene , dropdown_opts : [ { &quot;Option 1&quot; , &quot;Option 1&quot; } , { &quot;Option 2&quot; , &quot;Option 2&quot; } , { &quot;Option 3&quot; , &quot;Option 3&quot; } ] , dropdown_value : &quot;Option 1&quot; ) end def mounted ( scene ) do send_event ( scene , :dropdown , :set_value , &quot;Option 2&quot; ) end def render ( assigns ) do ~G&quot;&quot;&quot; &lt;%= graph font_size: 20 %&gt; &lt;%= primitive Scenic.Primitive.Text, &quot;selected value \#{@dropdown_value}&quot;, id: :dropdown_value_text, translate: {20, 80} %&gt; &lt;%= component Scenic.Component.Input.Dropdown, { @dropdown_opts, @dropdown_value }, id: :dropdown, translate: {20, 20} %&gt; &quot;&quot;&quot; end def process_event ( { :value_changed , :dropdown , value } , _ , scene ) do { :noreply , assign ( scene , dropdown_value : value ) } end end","ref":"SnapFramework.Scene.html"},{"type":"callback","title":"SnapFramework.Scene.mount/1","doc":"Called after graph is initialized. Usually for sending events to child components.","ref":"SnapFramework.Scene.html#c:mount/1"},{"type":"callback","title":"SnapFramework.Scene.process_call/3","doc":"Called when a scene receives a call message. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_call/3"},{"type":"callback","title":"SnapFramework.Scene.process_cast/2","doc":"Called when a scene receives a cast message. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_cast/2"},{"type":"callback","title":"SnapFramework.Scene.process_event/3","doc":"Called when a scene receives an event message. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_event/3"},{"type":"callback","title":"SnapFramework.Scene.process_fetch/2","doc":"Called when a scene receives a fetch message. Use this to return data to the caller. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_fetch/2"},{"type":"callback","title":"SnapFramework.Scene.process_get/2","doc":"Called when a scene receives a get message. Use this to return data to the caller. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_get/2"},{"type":"callback","title":"SnapFramework.Scene.process_info/2","doc":"Called when a scene receives a message. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_info/2"},{"type":"callback","title":"SnapFramework.Scene.process_input/3","doc":"Called when a scene receives an input messsage. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_input/3"},{"type":"callback","title":"SnapFramework.Scene.process_put/2","doc":"Called when a scene receives a put message. Use this to update data on your state. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_put/2"},{"type":"callback","title":"SnapFramework.Scene.process_update/3","doc":"Called when a scene receives an update message. Use this to update data and options on your state. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_update/3"},{"type":"callback","title":"SnapFramework.Scene.render/1","doc":"","ref":"SnapFramework.Scene.html#c:render/1"},{"type":"callback","title":"SnapFramework.Scene.setup/1","doc":"Called before graph is initialized. This is for setting up assigns used by your graph or subscribing to input or PubSub messages.","ref":"SnapFramework.Scene.html#c:setup/1"},{"type":"module","title":"SnapFramework.Engine","doc":"The EEx template engine. Overview The SnapFramework Engine is responsible for parsing EEx templates and building graphs from them. You should always start a template with the a graph, and then add any components and primitives immediately after it. &lt; % = graph font_size : 20 % &gt; &lt; % = component Scenic.Component.Button , &quot;button text&quot; , id : :btn % &gt; &lt; % = primitive Scenic.Primitive.Rectangle , { 100 , 100 } , id : :rect , fill : :steel_blue % &gt; In the above example you can see how simple it is to render component and primitives. Layouts The templating engine also supports layouts. &lt; % = graph font_size : 20 % &gt; &lt; % = layout padding : 100 , width : 600 , height : 600 , translate : { 100 , 10 } do % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = layout padding : 0 , width : 600 , height : 300 , translate : { 10 , 10 } do % &gt; &lt; % = component Scenic.Component.Input.Dropdown , { @dropdown_opts , @dropdown_value } , id : :dropdown_1 , z_index : 100 % &gt; &lt; % = component Scenic.Component.Input.Dropdown , { @dropdown_opts , @dropdown_value } , id : :dropdown_2 % &gt; &lt; % end % &gt; &lt; % end % &gt; The only required options on templates are width and height . Any nested layouts will have the padding and translate of the previous layout added onto it. Any components rendered within a layout are added directly to the graph. Which means you can modify them directly in the scene you're working in. There is no parent component that is rendered.","ref":"SnapFramework.Engine.html"},{"type":"function","title":"SnapFramework.Engine.encode_to_iodata!/1","doc":"","ref":"SnapFramework.Engine.html#encode_to_iodata!/1"},{"type":"module","title":"SnapFramework.Engine.Builder","doc":"Overview This module is responsible for taking the parsed EEx template and building the graph.","ref":"SnapFramework.Engine.Builder.html"},{"type":"function","title":"SnapFramework.Engine.Builder.build_graph/2","doc":"","ref":"SnapFramework.Engine.Builder.html#build_graph/2"}]